;----------------------------------------------;
; Unpacker                                     ;
;----------------------------------------------;

Global nofpackfiles

Function initpackfile()
	
	file = ReadFile("res1.dat")
	index = 0
	Repeat
		
		packfilename(index) = Lower(ReadString(file))
		packfileposition(index) = ReadInt(file)
		packfilelength(index) = ReadInt(file)
		index = index + 1
	Until Eof(file)
	
	nofpackfiles = index
	
	CloseFile(file)
	
End Function

Function pack$(file$)
	
	Local ext$
	
	If Lower(Right(file, 4)) = ".3ds" Then
		ext = ".3ds"
	ElseIf Lower(Right(file, 2)) = ".x" Then
		ext = ".x"
	Else
		ext = ".tmp"
	EndIf
	
	dir = ReadDir(CurrentDir())
	Repeat
		file2$ = NextFile(dir)
		
		If Lower(Right(file2, 4)) = ".tmp" Or Lower(Right(file2, 4)) = ".3ds" Or Lower(Right(file2, 2)) = ".x" Then
			DeleteFile(file2)
		EndIf
	Until file2 = ""
	CloseDir(dir)
	
	For i = 0 To nofpackfiles - 1
		
		If Lower(file) = packfilename(i) Then
			f = ReadFile("res2.dat")
						
			out = WriteFile(Str(packfilecount) + ext)
			
			SeekFile(f, packfileposition(i))
			
			For j = 1 To packfilelength(i)
				WriteByte(out, ReadByte(f))
			Next
			
			CloseFile(out)
			CloseFile(f)
			
			Exit
		EndIf
		
	Next
	
	packfilecount = packfilecount + 1
	
	Return Str(packfilecount - 1) + ext
	
End Function

;----------------------------------------------;
; Loaders                                      ;
;----------------------------------------------;

Function myloadtexture(texture$, flags)
	
	tex = LoadTexture(pack(texture), flags)
	If Not tex Then
		tex = LoadTexture(texture, flags)
	EndIf
	
	If Not tex Then
		globalerror("Couldn't load Texture: " + texture + ", Flag " + Str(flags))
	EndIf
	
	Return tex
	
End Function

Function myloadanimtexture(texture$, flags, width, height, firs, count)
	
	tex = LoadAnimTexture(pack(texture), flags, width, height, firs, count)
	If Not tex Then
		tex = LoadAnimTexture(texture, flags, width, height, firs, count)
	EndIf
	
	If Not tex Then
		globalerror("Couldn't load AnimTexture: " + texture + ", Flag " + Str(flags))
	EndIf
	
	Return tex
	
End Function

Function myloadmd2(model$)
	
	mdl = LoadMD2(pack(model), 0)
	If Not mdl Then
		mdl = LoadMD2(model, 0)
	EndIf
	
	If Not mdl Then
		globalerror("Couldn't load MD2: " + model)
	EndIf
	
	Return mdl
	
End Function

Function myloadmesh(model$)
	
	mdl = LoadMesh(pack(model), 0)
	If Not mdl Then
		mdl = LoadMesh(model, 0)
	EndIf
	
	If Not mdl Then
		globalerror("Couldn't load Mesh: " + model)
	EndIf
	
	Return mdl
	
End Function

Function myloadsound(sound$)
	
	snd = LoadSound(pack(sound))
	If Not snd Then
		doessoundexist = 0
	EndIf
	
	Return snd
	
End Function